// MAIN.CPP (MOUSE.EXE)
// (C) 1994 Ahpah Software Inc.
// Description: System interface.

#include <stdio.h>
#include <stdlib.h>
#include "defs.h"
#include "graph.h"
#include "system.h"

/* main variables
 */
GR_IMAGE mouse;
GR_FXIMAGE fxi;
GR_IMAGE backgr;
GREVENT event;
WORD fullscr[GR_VECT] = { 0, 0, GR_XMAX, GR_YMAX };

/* main() gets control from the system
 */
VOID main( INDEX argc, STRING *argv )
    {
    if( argc < 3 )
	{
	printf( "\nSyntax: mouse backfilename cursorfilename\n\n" );
	exit( 1 );
	}
    sys_starter();
    printf( "\n%s Version %s\n%s\n\n", PROG_NAME, PROG_VER, PROG_CRHT );
    gr_starter();

    // load background and display
    gr_imageload( &backgr, argv[1] );
    gr_imageshow( &backgr, fullscr );
    gr_imagefree( &backgr );

    // load mouse cursor
    gr_imageload( &mouse, argv[2] );
    gr_fxcreate( &mouse, &fxi );

    // set cursor to bitmap, when in [100,100,300,300] switch to built-in
    // internal arrow pointer
    gr_cursorset( &fxi );
    while( event.mask != grERPRESS )
	{
	if( event.mask == grEMOUSEMOVE )
	    {
	    if( gr_mousein( &event, 100, 100, 300, 300 ) )
		gr_cursorset( grCARROW, gxRGBPacked( 255, 255, 255 ) );
	    else
		gr_cursorset( &fxi );
	    }
	gr_getevent( &event );
	}

    // free memory and exit
    gr_imagefree( &mouse );
    gr_fxfree( &fxi );
    gr_ender();
    }

